/** $VER: Rcap3 1.1 (05.09.97)
 ** Auteur: Fabrice SABATIER
 **
 ** Commande Arexx sous GestaLivre V2.0.
 **
 ** Composition des pages d'criture.
 **
 **/

OPTIONS RESULTS

NL                  = '0a'x
SautPage            = '0C'x   /* caractre de saut de page */
ESC                 = '1B'x

/*****************  Dfinit les variables d'environnement   ***********************/

ADDRESS COMMAND "SYS:Rexxc/rx ENV:GestaCompte.ARexxPrfs" /* execute le script de dfinitions des prfrences */
NOM_PORT_LIVRE   =GETCLIP('Port_Livre')
NOM_ECRAN_PUB    =GETCLIP('Ecran_Livre')

/************************************************************************/

/*SIGNAL ON SYNTAX*/        /* dtourne les messages d'erreurs */

/* ouvre la library rexxreqtools.library pour les messages d'erreurs */
call addlib("rexxreqtools.library",0,-30,0)

ADDRESS VALUE NOM_PORT_LIVRE /* adresse du port Arexx */

nbre=0
NumeroLigne=0          /* initialisation des variables */
NumeroPage=1
Somme630=0
Somme635=0
Somme631=0
Somme633=0
Somme634=0
Somme637=0
Somme638=0
Somme641=0
Somme640=0
Somme650=0
Somme661=0
TotalSomme630=0
TotalSomme635=0
TotalSomme631=0
TotalSomme633=0
TotalSomme634=0
TotalSomme637=0
TotalSomme638=0
TotalSomme641=0
TotalSomme640=0
TotalSomme650=0
TotalSomme661=0
LettreMois.1='JANVIER'
LettreMois.2='FEVRIER'
LettreMois.3='MARS'
LettreMois.4='AVRIL'
LettreMois.5='MAI'
LettreMois.6='JUIN'
LettreMois.7='JUILLET'
LettreMois.8='AOUT'
LettreMois.9='SEPTEMBRE'
LettreMois.10='OCTOBRE'
LettreMois.11='NOVEMBRE'
LettreMois.12='DECEMBRE'
res=0

x=OPEN('infos','ram:recap3','w')  /* cre le fichier */

/* Entte du fichier */
CALL EnTete

DO mois=1 TO 12
  month mois                 /* se position sur le mois */

  Somme630=0
  Somme635=0
  Somme631=0
  Somme633=0
  Somme634=0
  Somme637=0
  Somme638=0
  Somme641=0
  Somme640=0
  Somme650=0
  Somme661=0

  numboperations             /* cherche le nombre d'oprations dans le mois */
  nbre= result

  DO i=1 TO nbre             /* passe toutes les oprations une  une */
   operation i
   PARSE VAR result . '/' . '/' Nature '/' Somme '/' . '/' Poste '/' .

   IF Poste="630   " THEN Somme630=Somme630+Somme  /* calcul le total du mois */
   IF Poste="635   " THEN Somme635=Somme635+Somme  /* suivant le compte       */
   IF Poste="631   " THEN Somme631=Somme631+Somme
   IF Poste="633   " THEN Somme633=Somme633+Somme
   IF Poste="634   " THEN Somme634=Somme634+Somme
   IF Poste="637   " THEN Somme637=Somme637+Somme
   IF Poste="638   " THEN Somme638=Somme638+Somme
   IF Poste="641   " THEN Somme641=Somme641+Somme
   IF Poste="640   " THEN Somme640=Somme640+Somme
   IF Poste="650   " THEN Somme650=Somme650+Somme
   IF Poste="661   " THEN Somme661=Somme661+Somme
  END

  TotalSomme630=TotalSomme630+Somme630   /* somme total en fin d'anne pour chaque */
  TotalSomme635=TotalSomme635+Somme635   /* compte */
  TotalSomme631=TotalSomme631+Somme631
  TotalSomme633=TotalSomme633+Somme633
  TotalSomme634=TotalSomme634+Somme634
  TotalSomme637=TotalSomme637+Somme637
  TotalSomme638=TotalSomme638+Somme638
  TotalSomme641=TotalSomme641+Somme641
  TotalSomme640=TotalSomme640+Somme640
  TotalSomme650=TotalSomme650+Somme650
  TotalSomme661=TotalSomme661+Somme661

 ligne='|'
 CALL ComposeLigne
 ligne= '|    'LEFT(lettremois.mois,12' ')||ligne

 NumeroLigne=NumeroLigne+1
 ligneImp= RIGHT(NumeroLigne,2,' ')||ligne
 res=WRITELN('infos',ligneImp)
END

 CALL Total

x=CLOSE('infos')       /* ferme le fichier */
EXIT

/*---------------- Entte du Tableau --------------*/
EnTete:
traitH="  --------------------------------------------------------------------------------------------------------------------------------"
Entete="  |    LIBELLE     |   630   |   635   |   631   |   633   |   634   |   637   |   638   |   641   |   640   |   650   |   661   |"
res=WRITELN('infos',ESC||'[4w')
res=WRITELN('infos','                                            RECAPITULATION (3me Partie)                             page 'NumeroPage)
showyear
res=WRITELN('infos','     ANNEE: '||result)
res=WRITELN('infos','      MOIS: ')
res=WRITELN('infos',traitH)
res=WRITELN('infos',Entete)
res=WRITELN('infos',traitH)
/* Ecrit les lignes des donnes dans le fichier */
ligne=" R|                |         |         |         |         |         |         |         |         |         |         |         |"
res=WRITELN('infos',ligne)
RETURN

/*----------------  Edition d'une ligne -----------------------*/
ComposeLigne:
IF Somme630>0 THEN ligne= ligne || RIGHT(Somme630,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme635>0 THEN ligne= ligne || RIGHT(Somme635,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme631>0 THEN ligne= ligne || RIGHT(Somme631,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme633>0 THEN ligne= ligne || RIGHT(Somme633,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme634>0 THEN ligne= ligne || RIGHT(Somme634,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme637>0 THEN ligne= ligne || RIGHT(Somme637,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme638>0 THEN ligne= ligne || RIGHT(Somme638,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme641>0 THEN ligne= ligne || RIGHT(Somme641,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme640>0 THEN ligne= ligne || RIGHT(Somme640,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme650>0 THEN ligne= ligne || RIGHT(Somme650,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme661>0 THEN ligne= ligne || RIGHT(Somme661,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
RETURN

/*---------------- Total du Tableau  --------------*/
Total:
res=WRITELN('infos',traitH)
ligne="|"
IF TotalSomme630>0 THEN ligne= ligne || RIGHT(TotalSomme630,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme635>0 THEN ligne= ligne || RIGHT(TotalSomme635,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme631>0 THEN ligne= ligne || RIGHT(TotalSomme631,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme633>0 THEN ligne= ligne || RIGHT(TotalSomme633,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme634>0 THEN ligne= ligne || RIGHT(TotalSomme634,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme637>0 THEN ligne= ligne || RIGHT(TotalSomme637,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme638>0 THEN ligne= ligne || RIGHT(TotalSomme638,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme641>0 THEN ligne= ligne || RIGHT(TotalSomme641,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme640>0 THEN ligne= ligne || RIGHT(TotalSomme640,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme650>0 THEN ligne= ligne || RIGHT(TotalSomme650,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF TotalSomme661>0 THEN ligne= ligne || RIGHT(TotalSomme661,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'

res=WRITELN('infos','14|     TOTAL      '||ligne)
res=WRITELN('infos',ESC||'[3w')
RETURN

/* Traite les messages d'erreurs */
SYNTAX:
IF RC=13 THEN call rtezrequest( "      Environnement serveur non trouv !!!" || NL || NL ||,
                                "Le nom du port ARexx utilis dans le script est : "|| NL || NL ||,
                                "-----------------------------------------------"|| NL ||,
                                "                  " || NOM_PORT_LIVRE || NL ||,
                                "-----------------------------------------------"|| NL || NL ||,
                                "Note : Pour rparer ceci, veuillez fermer le module"|| NL ||,
				"       'Livre' et modifier le type d'outil 'REXX' de"|| NL ||,
				"       l'icne, puis le relancer."|| NL || NL ||,
				"       ATTENTION aux minuscules/majuscules      ",,
				"OK", "Informations","rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")
ELSE call rtezrequest(errortext(RC),"Vu",,"rt_pubscrname="||NOM_PORT_LIVRE "rt_font=Gestacompte.font/8")
EXIT
