/** $VER: Rcapitulation 1.1 (05.09.97)
 ** Auteur: Fabrice SABATIER
 **
 ** Commande ARexx sous GestaLivre V2.0.
 **
 ** Composition des pages d'criture.
 **
 **/

OPTIONS RESULTS

NL = '0a'x

/*****************  Dfinit les variables d'environnement   ***********************/

ADDRESS COMMAND "SYS:Rexxc/rx ENV:GestaCompte.ARexxPrfs" /* execute le script de dfinitions des prfrences */
NOM_PORT_LIVRE   =GETCLIP('Port_Livre')
NOM_ECRAN_PUB    =GETCLIP('Ecran_Livre')

/************************************************************************/

SIGNAL ON SYNTAX        /* dtourne les messages d'erreurs */

/* ouvre la library rexxreqtools.library pour les messages d'erreurs */
call addlib("rexxreqtools.library",0,-30,0)

ADDRESS VALUE NOM_PORT_LIVRE /* adresse du port Arexx */

call rtezrequest( "Quelle partie du livre voulez-vous voir ?" || NL ||  NL ||,
                  "     Tableau1: Entres de 420  590" || NL ||,
                  "     Tableau2: Sorties de 590  620" || NL ||,
                  "     Tableau3: Sorties de 630  661" || NL ||,
                  "     Tableau4: Sorties de 662  629",,
                  "Tableau_1|Tableau_2|Tableau_3|Tableau_4|_Annuler",,"rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")

if rtresult = 0 then EXIT
if rtresult = 1 then DO
                  ADDRESS command
                  'sys:rexxc/rx Gesta:scripts_arexx/Recap1.rexx'
                  'GESTA:Gestaffiche ram:recap1'
                  'Delete ram:recap1'
                      END
if rtresult = 2 then DO
                  ADDRESS command
                  'sys:rexxc/rx Gesta:scripts_arexx/Recap2.rexx'
                  'GESTA:Gestaffiche ram:recap2'
                  'Delete ram:recap2'
                      END
if rtresult = 3 then DO
                  ADDRESS command
                  'sys:rexxc/rx Gesta:scripts_arexx/Recap3.rexx'
                  'GESTA:Gestaffiche ram:recap3'
                  'Delete ram:recap3'
                      END
if rtresult = 4 then DO
                  ADDRESS command
                  'sys:rexxc/rx Gesta:scripts_arexx/Recap4.rexx'
                  'GESTA:Gestaffiche ram:recap4'
                  'Delete ram:recap4'
                      END

EXIT                          /* sort */

/* Traite les messages d'erreurs */
SYNTAX:
IF RC=13 THEN call rtezrequest( "      Environnement serveur non trouv !!!" || NL || NL ||,
                                "Le nom du port ARexx utilis dans le script est : "|| NL || NL ||,
                                "-----------------------------------------------"|| NL ||,
                                "                  " || NOM_PORT_LIVRE || NL ||,
                                "-----------------------------------------------"|| NL || NL ||,
                                "Note : Pour rparer ceci, veuillez fermer le module"|| NL ||,
				"       'Livre' et modifier le type d'outil 'REXX' de"|| NL ||,
				"       l'icne, puis le relancer."|| NL || NL ||,
				"       ATTENTION aux minuscules/majuscules      ",,
				"OK", "Informations","rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")
ELSE call rtezrequest(errortext(RC),"Vu",,"rt_pubscrname="||NOM_PORT_LIVRE "rt_font=Gestacompte.font/8")
EXIT
