/** $VER: Tab3 1.2 (05.09.97)
 ** Auteur: Fabrice SABATIER
 **
 ** Commande ARexx sous GestaLivre V2.0.
 **
 ** Cration des tableaux en ARexx pour un cabinet mdical.
 **
 **/

OPTIONS RESULTS

NL                  = '0a'x
SautPage            = '0C'x   /* caractre de saut de page */
ESC                 = '1B'x

/*****************  Dfinit les variables d'environnement   ***********************/

ADDRESS COMMAND "SYS:Rexxc/rx ENV:GestaCompte.ARexxPrfs" /* execute le script de dfinitions des prfrences */
NOM_PORT_LIVRE   =GETCLIP('Port_Livre')
NOM_ECRAN_PUB    =GETCLIP('Ecran_Livre')

/************************************************************************/

SIGNAL ON SYNTAX        /* dtourne les messages d'erreurs */

/* ouvre la library rexxreqtools.library pour les messages d'erreurs */
call addlib("rexxreqtools.library",0,-30,0)

ADDRESS VALUE NOM_PORT_LIVRE /* adresse du port Arexx */

nbre=0
NumeroLigne=0        /* initialisation des variables */
NumeroPage=1
TotalLignes=30
Somme630=0
Somme635=0
Somme631=0
Somme633=0
Somme634=0
Somme637=0
Somme638=0
Somme641=0
Somme640=0
Somme650=0
Somme661=0

LettreMois.01='JANVIER'
LettreMois.02='FEVRIER'
LettreMois.03='MARS'
LettreMois.04='AVRIL'
LettreMois.05='MAI'
LettreMois.06='JUIN'
LettreMois.07='JUILLET'
LettreMois.08='AOUT'
LettreMois.09='SEPTEMBRE'
LettreMois.10='OCTOBRE'
LettreMois.11='NOVEMBRE'
LettreMois.12='DECEMBRE'
res=0

x=OPEN('infos','ram:Tableau3','w')  /* cre le fichier */

operation 1
PARSE VAR result . '/' mois '/' .  /* rcupre le mois slectionn */

/* Entte du fichier */
CALL Tableau3EnTete

numboperations             /* cherche le nombre d'oprations dans le mois */
nbre= result

DO i=1 TO nbre             /* passe toutes les oprations une  une */
operation i
 PARSE VAR result . '/' . '/' . '/' Somme '/' Libelle '/' Poste '/' .

IF i=TotalLignes THEN DO   /* toutes les 30me oprations on passe  la page suivante */
                       NumeroPage=NumeroPage+1
                       CALL Tableau3Total
                       res=WRITELN('infos',SautPage)
                       NumeroLigne=0
                       CALL Tableau3EnTete
                       TotalLignes=TotalLignes+29
                      END
/* Composition d'une ligne */

ligne= '|'LEFT(libelle,16,' ')'|'

IF Poste="630   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme630=Somme630+Somme
                       END
ELSE ligne= ligne||"         "

ligne= ligne'|'

IF Poste="635   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme635=Somme635+Somme
                       END

ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="631   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme631=Somme631+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="633   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme633=Somme633+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="634   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme634=Somme634+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="637   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme637=Somme637+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="638   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme638=Somme638+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="641   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme641=Somme641+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="640   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme640=Somme640+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="650   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme650=Somme650+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="661   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme661=Somme661+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'


NumeroLigne=NumeroLigne+1
ligneImp= RIGHT(NumeroLigne,2,' ')||ligne
res=WRITELN('infos',ligneImp)
END

CALL Tableau3Total

x=CLOSE('infos')       /* ferme le fichier */

EXIT

/*---------------- Total du Tableau 3 --------------*/
Tableau3Total:
res=WRITELN('infos',traitH)
ligne="AR|                |"
CALL ComposeLigne
res=WRITELN('infos',ligne || '|')
res=WRITELN('infos',ESC||'[3w')

RETURN

/*---------------- Entte du Tableau 3 --------------*/
Tableau3EnTete:
traitH="  --------------------------------------------------------------------------------------------------------------------------------"
Entete="  |    LIBELLE     |   630   |   635   |   631   |   633   |   634   |   637   |   638   |   641   |   640   |   650   |   661   |"
res=WRITELN('infos',ESC||'[4w')
res=WRITELN('infos','                                            FEUILLE COMPTABLE (3me Partie)                         page 'NumeroPage)
showyear
res=WRITELN('infos','     ANNEE: '||result)
res=WRITELN('infos','      MOIS: 'lettremois.mois)
res=WRITELN('infos',traitH)
res=WRITELN('infos',Entete)
res=WRITELN('infos',traitH)

/* Ecrit les lignes des donnes dans le fichier */
ligne=" R|                |"
CALL ComposeLigne
ligne= ligne'|'

res=WRITELN('infos',ligne)

RETURN


ComposeLigne:
IF Somme630>0 THEN ligne= ligne || RIGHT(Somme630,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme635>0 THEN ligne= ligne || RIGHT(Somme635,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme631>0 THEN ligne= ligne || RIGHT(Somme631,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme633>0 THEN ligne= ligne || RIGHT(Somme633,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme634>0 THEN ligne= ligne || RIGHT(Somme634,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme637>0 THEN ligne= ligne || RIGHT(Somme637,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme638>0 THEN ligne= ligne || RIGHT(Somme638,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme641>0 THEN ligne= ligne || RIGHT(Somme641,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme640>0 THEN ligne= ligne || RIGHT(Somme640,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme650>0 THEN ligne= ligne || RIGHT(Somme650,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme661>0 THEN ligne= ligne || RIGHT(Somme661,9,' ')
ELSE ligne= ligne||"         "
RETURN

/* Traite les messages d'erreurs */
SYNTAX:
IF RC=13 THEN call rtezrequest( "      Environnement serveur non trouv !!!" || NL || NL ||,
                                "Le nom du port ARexx utilis dans le script est : "|| NL || NL ||,
                                "-----------------------------------------------"|| NL ||,
                                "                  " || NOM_PORT_LIVRE || NL ||,
                                "-----------------------------------------------"|| NL || NL ||,
                                "Note : Pour rparer ceci, veuillez fermer le module"|| NL ||,
				"       'Livre' et modifier le type d'outil 'REXX' de"|| NL ||,
				"       l'icne, puis le relancer."|| NL || NL ||,
				"       ATTENTION aux minuscules/majuscules      ",,
				"OK", "Informations","rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")
ELSE call rtezrequest(errortext(RC),"Vu",,"rt_pubscrname="||NOM_PORT_LIVRE "rt_font=Gestacompte.font/8")
EXIT
