/** $VER: Tab4 1.2 (05.09.97)
 ** Auteur: Fabrice SABATIER
 **
 ** Commande ARexx sous GestaLivre V2.0.
 **
 ** Cration des tableaux en ARexx pour un cabinet mdical.
 **
 **/

OPTIONS RESULTS

NL                  = '0a'x
SautPage            = '0C'x   /* caractre de saut de page */
ESC                 = '1B'x

/*****************  Dfinit les variables d'environnement   ***********************/

ADDRESS COMMAND "SYS:Rexxc/rx ENV:GestaCompte.ARexxPrfs" /* execute le script de dfinitions des prfrences */
NOM_PORT_LIVRE   =GETCLIP('Port_Livre')
NOM_ECRAN_PUB    =GETCLIP('Ecran_Livre')

/************************************************************************/

SIGNAL ON SYNTAX        /* dtourne les messages d'erreurs */

/* ouvre la library rexxreqtools.library pour les messages d'erreurs */
call addlib("rexxreqtools.library",0,-30,0)

ADDRESS VALUE NOM_PORT_LIVRE /* adresse du port Arexx */

nbre=0
NumeroLigne=0        /* initialisation des variables */
NumeroPage=1
TotalLignes=30
Somme662=0
Somme664=0
Somme665=0
Somme666=0
Somme669=0
Somme670=0
Somme467=0
Somme421=0
Somme200=0
Somme629=0
SommeDiv=0
LettreMois.01='JANVIER'
LettreMois.02='FEVRIER'
LettreMois.03='MARS'
LettreMois.04='AVRIL'
LettreMois.05='MAI'
LettreMois.06='JUIN'
LettreMois.07='JUILLET'
LettreMois.08='AOUT'
LettreMois.09='SEPTEMBRE'
LettreMois.10='OCTOBRE'
LettreMois.11='NOVEMBRE'
LettreMois.12='DECEMBRE'
res=0

x=OPEN('infos','ram:Tableau4','w')  /* cre le fichier */

operation 1
PARSE VAR result . '/' mois '/' .  /* rcupre le mois slectionn */

/* Entte du fichier */
CALL Tableau4EnTete

numboperations             /* cherche le nombre d'oprations dans le mois */
nbre= result

DO i=1 TO nbre             /* passe toutes les oprations une  une */
operation i
 PARSE VAR result . '/' . '/' . '/' Somme '/' Libelle '/' Poste '/' .

IF i=TotalLignes THEN DO   /* toutes les 30me oprations on passe  la page suivante */
                       NumeroPage=NumeroPage+1
                       CALL Tableau4Total
                       res=WRITELN('infos',SautPage)
                       NumeroLigne=0
                       CALL Tableau4EnTete
                       TotalLignes=TotalLignes+29
                      END

/* Composition d'une ligne */
ligne= '|'LEFT(libelle,16,' ')'|'

IF Poste="662   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme662=Somme662+Somme
                       END
ELSE ligne= ligne||"         "

ligne= ligne'|'

IF Poste="664   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme664=Somme664+Somme
                       END

ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="665   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme665=Somme665+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="666   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme666=Somme666+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="669   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme669=Somme669+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="670   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme670=Somme670+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="467   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme467=Somme467+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="421   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme421=Somme421+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="200   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme200=Somme200+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF Poste="629   " THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       Somme629=Somme629+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'

IF LEFT(Poste,3)="DIV" THEN DO
                       ligne= ligne||RIGHT(Somme,9,' ')
                       SommeDiv=SommeDiv+Somme
                       END
ELSE ligne= ligne||"         "
ligne= ligne'|'


NumeroLigne=NumeroLigne+1
ligneImp= RIGHT(NumeroLigne,2,' ')||ligne
res=WRITELN('infos',ligneImp)
END

CALL Tableau4Total

x=CLOSE('infos')       /* ferme le fichier */

EXIT

/*---------------- Total du Tableau 4 --------------*/
Tableau4Total:
res=WRITELN('infos',traitH)
ligne="AR|                |"
CALL ComposeLigne
res=WRITELN('infos',ligne || '|')
res=WRITELN('infos',ESC||'[3w')
RETURN

/*---------------- Entte du Tableau 4 --------------*/
Tableau4EnTete:
traitH="  --------------------------------------------------------------------------------------------------------------------------------"
Entete="  |    LIBELLE     |   662   |   664   |   665   |   666   |   669   |   670   |   467   |   421   |   200   |   629   |  Divers |"
res=WRITELN('infos',ESC||'[4w')
res=WRITELN('infos','                                            FEUILLE COMPTABLE (4me Partie)                        page 'NumeroPage)
showyear
res=WRITELN('infos','     ANNEE: '||result)
res=WRITELN('infos','      MOIS: 'lettremois.mois)
res=WRITELN('infos',traitH)
res=WRITELN('infos',Entete)
res=WRITELN('infos',traitH)

/* Ecrit les lignes des donnes dans le fichier */
ligne=" R|                |"
CALL ComposeLigne
res=WRITELN('infos',ligne'|')

RETURN

ComposeLigne:
IF Somme662>0 THEN ligne= ligne || RIGHT(Somme662,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme664>0 THEN ligne= ligne || RIGHT(Somme664,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme665>0 THEN ligne= ligne || RIGHT(Somme665,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme666>0 THEN ligne= ligne || RIGHT(Somme666,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme669>0 THEN ligne= ligne || RIGHT(Somme669,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme670>0 THEN ligne= ligne || RIGHT(Somme670,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme467>0 THEN ligne= ligne || RIGHT(Somme467,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme421>0 THEN ligne= ligne || RIGHT(Somme421,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme200>0 THEN ligne= ligne || RIGHT(Somme200,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF Somme629>0 THEN ligne= ligne || RIGHT(Somme629,9,' ')
ELSE ligne= ligne||"         "
ligne= ligne'|'
IF SommeDiv>0 THEN ligne= ligne || RIGHT(SommeDiv,9,' ')
ELSE ligne= ligne||"         "

RETURN

/* Traite les messages d'erreurs */
SYNTAX:
IF RC=13 THEN call rtezrequest( "      Environnement serveur non trouv !!!" || NL || NL ||,
                                "Le nom du port ARexx utilis dans le script est : "|| NL || NL ||,
                                "-----------------------------------------------"|| NL ||,
                                "                  " || NOM_PORT_LIVRE || NL ||,
                                "-----------------------------------------------"|| NL || NL ||,
                                "Note : Pour rparer ceci, veuillez fermer le module"|| NL ||,
				"       'Livre' et modifier le type d'outil 'REXX' de"|| NL ||,
				"       l'icne, puis le relancer."|| NL || NL ||,
				"       ATTENTION aux minuscules/majuscules      ",,
				"OK", "Informations","rt_pubscrname="||NOM_ECRAN_PUB "rt_font=Gestacompte.font/8")
ELSE call rtezrequest(errortext(RC),"Vu",,"rt_pubscrname="||NOM_PORT_LIVRE "rt_font=Gestacompte.font/8")
EXIT
