/** $VER: Tranfert 1.0 (05.08.97)
 ** Auteur: Fabrice SABATIER
 **
 ** Commande Arexx sous GestaCompte V2.1.
 **
 ** Transfert d'une transaction d'un compte vers un autre (Lib).
 **
 **/

OPTIONS RESULTS

NL = '0a'x

/*****************  Dfinit les variables d'environnement   ***********************/

ADDRESS COMMAND "SYS:Rexxc/rx ENV:GestaCompte.ARexxPrfs" /* excute le script de dfinitions des prfrences */
NOM_PORT_BANQUE1 =GETCLIP('Port_Banque3')
NOM_PORT_BANQUE2 =GETCLIP('Port_Banque4')
NOM_BANQUE2      =GETCLIP('Banque4')
NOM_ECRAN2       =GETCLIP('Ecran_Banque4')

/************************************************************************/


SIGNAL ON SYNTAX        /* dtourne les messages d'erreurs */

IF~SHOW(L,"rexxsupport.library")THEN DO
 IF~ADDLIB("rexxsupport.library",0,-30,0) THEN DO
     SAY "rexxsupport.library est introuvable !"
     EXIT
 END
END

/* ouvre la library rexxreqtools.library pour les messages d'erreurs */
call addlib("rexxreqtools.library",0,-30,0)

ADDRESS VALUE NOM_PORT_BANQUE1 /* adresse du port Arexx */

click                          /* demande la slection d'une transaction */
ligne=RESULT
operation ligne                /* retourne la ligne suivant son numro */

Banque=1
IF~SHOW(p,NOM_PORT_BANQUE2) THEN DO
  Banque=0
  ADDRESS COMMAND 'RUN >NIL: Gesta:GestaCompte '||NOM_BANQUE2||' s='||NOM_ECRAN2' p='||NOM_PORT_BANQUE2
  DO 10
     IF SHOW(p,NOM_PORT_BANQUE2) THEN DO
         Banque=1
         LEAVE
         END
     CALL DELAY(100)
  END
END


ADDRESS VALUE NOM_PORT_BANQUE2 /* adresse du port Arexx */
load force

PARSE VAR RESULT Jour '/' Mois '/' Nature '/'.'/'.'/'.'/'Somme'/'Libelle'/'Poste'/'.
enter Jour'|'Mois'|TRANSF|0|'Somme'|'Libelle'|'Poste
display
save force
quit


/* Traite les messages d'erreurs */
SYNTAX:
IF RC=13 THEN call rtezrequest( "Environnement serveur non trouv !!!" || NL ||,
                                "Le nom du port ARexx utilis dans"|| NL ||,
                                "le script est : " || NOM_PORT_BANQUE)
ELSE call rtezrequest(errortext(RC),"Vu",,"rt_pubscrname="||NOM_PORT_BANQUE)
EXIT

