/** $VER: Tranfert 1.0 (05.08.97)
 ** Auteur: Fabrice SABATIER
 **
 ** Commande Arexx sous GestaCompte V2.1.
 **
 ** Transfert d'une transaction d'un compte vers un autre (Med).
 **
 **/

OPTIONS RESULTS

NL = '0a'x

/*****************  Dfinit les variables d'environnement   ***********************/

ADDRESS COMMAND "SYS:Rexxc/rx ENV:GestaCompte.ARexxPrfs" /* excute le script de dfinitions des prfrences */
NOM_PORT_BANQUE1 =GETCLIP('Port_Banque3')
NOM_PORT_BANQUE2 =GETCLIP('Port_Banque4')

/************************************************************************/


SIGNAL ON SYNTAX        /* dtourne les messages d'erreurs */

/* ouvre la library rexxreqtools.library pour les messages d'erreurs */
call addlib("rexxreqtools.library",0,-30,0)

ADDRESS VALUE NOM_PORT_BANQUE2 /* adresse du port Arexx */

click                          /* demande la slection d'une transaction */
ligne=RESULT
operation ligne                /* retourne la ligne suivant son numro */

ADDRESS VALUE NOM_PORT_BANQUE1 /* adresse du port Arexx */

PARSE VAR RESULT Jour '/' Mois '/' Nature '/'.'/'.'/'.'/'Somme'/'Libelle'/'Poste'/'.
enter Jour'|'Mois'|TRANSF|0|'Somme'|'Libelle'|'Poste
display
EXIT                          /* sort */

/* Traite les messages d'erreurs */
SYNTAX:
IF RC=13 THEN call rtezrequest( "Environnement serveur non trouv !!!" || NL ||,
                                "Le nom du port ARexx utilis dans"|| NL ||,
                                "le script est : " || NOM_PORT_BANQUE)
ELSE call rtezrequest(errortext(RC),"Vu",,"rt_pubscrname="||NOM_PORT_BANQUE)
EXIT

